#ifndef __shape_rect_atd__
#define __shape_rect_atd__

//------------------------------------------------------------------------------
// shape_rect_atd.h -    - 
//------------------------------------------------------------------------------

#include "shape_atd.h"
#include "rectangle_atd.h"

//------------------------------------------------------------------------------

namespace simple_shapes {

  // ,   
  void In_shape_rectangle(shape* _this);     //     
  void Out_shape_rectangle(shape* _this);    //     
  double Area_shape_rectangle(shape* _this); //   
  void Destroy_shape_rectangle(shape* _this); //  

//------------------------------------------------------------------------------

  //    .
  //     .   
  //     
  static shape_vtbl rect_vtbl = {
    &In_shape_rectangle,     //     
    &Out_shape_rectangle,    //     
    &Area_shape_rectangle,   //   
    &Destroy_shape_rectangle //    
  };

//------------------------------------------------------------------------------

  // ,   -  .
  struct shape_rectangle {
    shape base;  //   
    rectangle r; //  .    .
  };

//------------------------------------------------------------------------------

} // end simple_shapes namespace

#endif