#ifndef __shape_trian_atd__
#define __shape_trian_atd__

//------------------------------------------------------------------------------
// shape_rect_atd.h -    - 
//------------------------------------------------------------------------------

#include "shape_atd.h"
#include "triangle_atd.h"

//------------------------------------------------------------------------------

namespace simple_shapes {

  // ,   
  void In_shape_triangle(shape* _this);     //     
  void Out_shape_triangle(shape* _this);    //     
  double Area_shape_triangle(shape* _this); //   
  void Destroy_shape_triangle(shape* _this); //  

//------------------------------------------------------------------------------

  //    .
  //     .   
  //     
  static shape_vtbl trian_vtbl = {
    &In_shape_triangle,     //     
    &Out_shape_triangle,    //     
    &Area_shape_triangle,   //   
    &Destroy_shape_triangle //    
  };

//------------------------------------------------------------------------------

  // ,   -  .
  struct shape_triangle {
    shape base;  //   
    triangle t; //  .    .
  };

//------------------------------------------------------------------------------

} // end simple_shapes namespace

#endif